unit AMHTimeLabel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TTimeFormat = (hhmm, hhmmss);

  TAMHTimeLabel = class(TLabel)
  private
    { Private-Deklarationen }
    FFormat: TTimeFormat;
    FTimer: TTimer;
    procedure SetFormat(Value: TTimeFormat);
  protected
    { Protected-Deklarationen }
    procedure OnTimer(Sender: TObject);
  public
    { Public-Deklarationen }
    constructor Create(AnOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published-Deklarationen }
    property Format: TTimeFormat read FFormat write SetFormat;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('AMH Free', [TAMHTimeLabel]);
end;

constructor TAMHTimeLabel.Create(AnOwner: TComponent);
begin
  inherited Create(AnOwner);
  FTimer := TTimer.Create(Self);
  FTimer.OnTimer := OnTimer;
  FFormat := hhmm;
  SetFormat(FFormat);
end;

destructor TAMHTimeLabel.Destroy;
begin
  FTimer.Free;
  inherited Destroy;
end;

procedure TAMHTimeLabel.OnTimer(Sender: TObject);
begin
  if FFormat = hhmm then
     Caption := FormatDateTime('hh:mm', Time)
  else
     Caption := FormatDateTime('hh:mm:ss', Time);
end;

procedure TAMHTimeLabel.SetFormat(Value: TTimeFormat);
begin
  if Value <> FFormat then
     FFormat := Value;
end;

end.
